#ifndef EyeCam_h
#define EyeCam_h

#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include "Camera.h"


// 8-bit definitions

#define VV6300_8_BLACK 16
#define VV6300_8_WHITE 224
#define VV6300_8_WIDTH 82
#define VV6300_8_HEIGHT 62
#define VV6300_8_BPP 24

#define VV6300_8_NUM_RAW 19520

void vv6300_8_colour_scan(void *ptr, int x, int y, int w,
                              unsigned char *line_buffer);
void vv6300_8_grey_scan(void *ptr, int x, int y, int w,
                            unsigned char *line_buffer);
void vv6300_8_read(unsigned char *frame);




// 4-bit definitions

#define VV6300_4_BLACK 16
#define VV6300_4_WHITE 224
#define VV6300_4_WIDTH 82
#define VV6300_4_HEIGHT 62
#define VV6300_4_BPP 12

#define VV6300_4_NUM_RAW 9760

void vv6300_4_colour_scan(void *ptr, int x, int y, int w,
                              unsigned char *line_buffer);
void vv6300_4_grey_scan(void *ptr, int x, int y, int w,
                            unsigned char *line_buffer);
void vv6300_4_read(unsigned char *frame);

class EyeCamera : public Camera {
  enum {
    EYECAM_4_BITS,
    EYECAM_8_BITS
  } mode;
  int camera_file;
 public:
  virtual bool open(IPL_CONFIG *ipl_config);
  virtual void close(void);
  virtual void read(Picture *p_frame);
  virtual bool iscolor(void);
  virtual void params(double p[]);
  virtual void get_info(CamInfo *info); 
  virtual bool get_IPL(IPL_CONFIG *ipl_config);

};

extern EyeCamera eyecamera;

#endif // EyeCam_h




